//
// javascript to render an items /details/ page from JSON output from the server.
// See the README-details.htm in this dir.
//
// NOTE: when "document" is undefined, that means we are doing
// "Server Side JavaScript" and there a couple minor differences...


//fixme reviews and textSection header/banner colors/fonts?


var IAD =
{
  // Details.inc sets these ("view source" on a /details/ page -- near bottom)
  identifier:"",
  mediatype:"",
  title:"",
  server:"",
  pages:false,



  log:function(str)
  {
    // Do not log if in production mode or special dev hosts
    if (typeof(location)!='undefined') {
      if (location.host.substr(0,4)!='www-') {
        return;
      }
      if (location.host.substr(0,8) == 'www-mang') {
        return;
      } else if (location.host.substr(0, 12) == 'www-testflip') {
        return;
      }
    }
  
    if (typeof(document)=='undefined')                    print(str); //SSJS
    else if (navigator.userAgent.indexOf('IE')>=0)        alert(str); //IE
    else if (navigator.userAgent.indexOf('Firefox')>=0  ||
             navigator.userAgent.indexOf('Safari') >=0)
    {
      if (typeof(console)!='undefined')                   console.log(str);
    }
  },



  // makes a hidden div become visible; makes a visible div become hidden
  tog:function(id)
  {
    var o=document.getElementById(id);
    if (o.style.display=='block')
      o.style.display='none';
    else
      o.style.display='block';
    return false;
  },


  // show/hide div OR table row
  toggle:function(id, tablerow)
  {
    var e = document.getElementById(id);
    var vis = (tablerow ? 'table-row' : 'block');
    
    if (navigator.appName=="Microsoft Internet Explorer")
      vis="block";
    
    if (e.style.display == vis)
      e.style.display = 'none';
    else
      e.style.display = vis;
    return false;
  },


  // Given a div identifier and media (mp3,flv,mp4) file, blip the HTML in the
  // div, replacing it with a flowplayer for the A/V file and start playing it!
  // (This is only for Zotero items (so far).)
  flowfile:function(avid, avfile)
  {
    var e = document.getElementById(avid);
    var showit = (typeof(e.style.display)=='undefined'  ||
                  e.style.display == ''  ||  e.style.display == 'none');
    
    // blip the showing player at "e" as well as every "av" row
    // (and if zotero gets > 10000 original media files, help us)
    for (var i=0; i<10000; i++)
    {
      var obj = document.getElementById('av'+i);
      if (!obj)
        break;
      obj.innerHTML = ' ';
      obj.style.display = 'none';
    }

    if (showit)
    {
      e.innerHTML =
      '<td colspan="5"><div id="flowplayerdiv" style="margin-left:auto; margin-right:auto; width:640px;"> </div></td>';

      var playlists = {'identifier':IAD.identifier};
      if (avfile.substr(avfile.length-4, 4)=='.mp3')
        playlists.mp3s = [IAD.identifier+'/'+avfile];
      else
        playlists.mp4s = [IAD.identifier+'/'+avfile];
      
      IAPlay.configPlayer(playlists);
      IAPlay.config.playlist[0].autoPlay = true;
      IAPlay.showPlayer();
      IAD.toggle(avid, true);
    }
    
    return false;
  },
    

  // parse a CGI arg
  arg:function(theArgName)
  {
    sArgs = location.search.slice(1).split('&');
    r = '';
    for (var i=0; i < sArgs.length; i++)
    {
      if (sArgs[i].slice(0,sArgs[i].indexOf('=')) == theArgName)
      {
        r = sArgs[i].slice(sArgs[i].indexOf('=')+1);
        break;
      }
    }
    return (r.length > 0 ? unescape(r).split(',') : '')
  },



  // development test function to show thumbnails "inline" on the /details/ page
  // and  be able to interact with the flowplayer and jump into movie midstream...
  filmstrip:function()
  {
    if (typeof(location)=='undefined' || location.host!='www-tracey.archive.org')
      return true;//makes "onclick" action that called us noop and go to real link
  
    var str = '<div onclick="document.getElementById(\'filmstrip\').style.display=\'none\'">';
    var ttl = this.pr(this.meta.metadata.title);
    for (var filocation in this.meta.files)
    {
      var fi = this.meta.files[filocation];
      if (this.pr(fi.format).toLowerCase() == 'thumbnail')
      {
        var sec = filocation.replace(/.*?([1-9][0-9]*)\.jpg/, "$1");
        var ttl2 = sec + ' seconds into \'' + ttl + '\'';
        var target = this.mp4s[0].replace(/\?start=[0-9\.]+/, '', this.mp4s[0]) +
          '?start='+sec;
        str += '<a href="" title="'+ttl2+'" alt="'+ttl2+
          '" onclick="IAD.mp4s[0]=\''+target+'\'; return IAPlay.insertPlayer();"><img style="display:block; margin:10px;" src="http://'+
          this.server + this.meta.dir + filocation + '"/></a>';
      }
    }
    str += '</div>';
    
    var bodyobj = document.getElementsByTagName("body")[0];
    var obj = document.createElement('div');
    obj.setAttribute('id', 'filmstrip');
    obj.setAttribute('style', 'text-align:center; background-color:black; width:180px; position:absolute; top:200px; left:28px;');
    obj.innerHTML = str;
    bodyobj.appendChild(obj);

    return false;
  },

  



  // for microfilm books with many months of newspapers in PDF
  //
  // paginfo is a logical hashmap JSON object of:
  //   YYYYMMDD => [comma separated list of pages]
  // eg:
  //   20080129 =>  "1,2,3,11,17"
  drawPDF:function(identifier, pageinfo)
  {
    var str='';
    var lastyearmonth=666;
    var urlstart = '/download/'+identifier+
    '/'+identifier+'_pdf.zip/'+identifier+'_pdf/'+identifier+'_';
    //console.log(urlstart);
    
    var multi_year=false;
    var last_year =false;
    for (var key in pageinfo)
    {
      var year     = key.substr(0,4);
      if (last_year===false) last_year=year;
      if (last_year != year) {
        multi_year=true;
        break;
      }
    }
    
    for (var key in pageinfo)
    {
      //console.log(pageinfo[key]);
      var pages    = pageinfo[key].split(",");
      var year     = key.substr(0,4);
      var month    = key.substr(4,2);
      var day      = key.substr(6,2);
      var yearmonth= year + '-' + month;
      var skip_day = false;
      if (yearmonth != lastyearmonth)
      {
        /**/ if (month== 1) monthName=("January");
        else if (month== 2) monthName=("February");
        else if (month== 3) monthName=("March");
        else if (month== 4) monthName=("April");
        else if (month== 5) monthName=("May");
        else if (month== 6) monthName=("June");
        else if (month== 7) monthName=("July");
        else if (month== 8) monthName=("August");
        else if (month== 9) monthName=("September");
        else if (month==10) monthName=("October");
        else if (month==11) monthName=("November");
        else if (month==12) monthName=("December");
        else if (month===undefined) monthName=("Single Page PDFs");
        else /*          */ monthName=("Unknown_" + month);
        
        if (multi_year) monthName = year + ' ' + monthName;
        
        // make header/a that shows/hides a hidden div after it with the
        // month's data
        str +=
          (str == '' ? '' : '</div><!--mo--><br/>')+
          '<a href="#'+monthName+','+year+'" onclick="return IAD.tog(\'m'+
          yearmonth+'\')">+<img src="/images/folder.png"/> <u>'+monthName+
          '</u></a>'+'<div class="mo" id="m'+yearmonth+'">';
      }
      
      // make header/a that shows/hides a hidden div after it with the page data
      if ((day===undefined)||(day=='')) skip_day=true;
      if (skip_day)
      {
        str += '<div class="day">';
      }
      else
      {
        str +=
        '<div class="day"><a href="#'+yearmonth+'-'+day+
        '" onclick="return IAD.tog(\'m'+yearmonth+
        'd'+day+'\')">+<img src="/images/folder.png"/> <u>'+day+
        '</u></a> <div class="pages" id="m'+yearmonth+'d'+day+'">';
      }
      
      // drop in the individual page links
      
      var offset = 1,page,pnum;
      for (j=0; j < pages.length; j++)
      {
        page = pages[j];
        if (!page)
          continue;
        if (offset>0) offset=1-page;
        pnum=parseInt(page)+offset;
        
        // left 0-pad to 4 digits as needed
        page = '0000'+page;
        page = page.substr(page.length-4, 4);
        
        var url = urlstart + page + '.pdf';
        str += '<a href="'+url+'">['+pnum+']</a> ';
      }
      
      if (skip_day)
        str += '</div>';
      else
        str += '</div><!--pages-->' + '</div><!--day-->';

      lastyearmonth = yearmonth;
    }

    str += '</div><!--mo-->';
    
    // replace the "pdfs" empty div with our hefty HTML
    var o=document.getElementById('pdfs');
    //alert(str);
    o.innerHTML = str;
    return false;
  },

  

  flowplayinsert:function()
  {
    IAPlay.configPlayer(this.playlists);
    
    if (typeof(this.playlists.mp3s)!='undefined')
      return IAPlay.showPlayer();
    
    if (!this.arg('start'))
      return IAPlay.click2play();

    // movies where supposed to jump right in...
    IAPlay.showPlayer();
    IAPlay.player.play();
    return false;
  },



  // NOTE!  for "this.[something]" variables (below),
  // Details.inc sets these ("view source" on a /details/ page -- near bottom)
  bodyLoaded:function()
  {
    //this.log('bodyLoaded');
    
    // IE is lame when it comes to tables being 100% wide...
    if (navigator.userAgent.indexOf('IE')>=0)
    {
      for (var i=0; i<10; i++)
      {
        // pick a "known safe" max width (search for "min-width" further above)
        var obj = document.getElementById('ff'+i);
        if (obj)
          obj.style.width = '640px'; 
      }
    }

    
    // if there are no media files appropriate for our flash player, we won't
    // bother with wasting time loading flash
    if (this.playlists)
      this.flowplayinsert();
    
    if (this.pages)
      this.drawPDF(this.identifier, this.pages);
  }
}; // end IAD definition
